diff -ruN ccp4srs-old/ccp4srs/ccp4srs_bond.cpp ccp4srs/ccp4srs/ccp4srs_bond.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_bond.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_bond.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_bond.cpp, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_bond.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010-2011.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,310 +22,317 @@
 //
 //  =================================================================
 //
-//    18.10.11   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_bond  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSBond  - atom description class
+//  **** Classes :  ccp4srs::Bond  - atom description class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010-2011
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
 
-#ifndef  __STRING_H
 #include <string.h>
-#endif
 
 #include "ccp4srs_bond.h"
+#include "ccp4srs_types.h"
 #include "ccp4srs_defs.h"
 
-CCP4SRSBond::CCP4SRSBond()  {
-  atom_1          = -1;
-  atom_2          = -1;
-  bond_order      = CCP4SRSBond::noOrder;
-//  bond_type       = CCP4SRSBond::noType;
-  bond_length     = 0.0;
-  bond_length_esd = 0.0;
-}
-
-CCP4SRSBond::~CCP4SRSBond()  {
-}
-
-
-void  get_bond_type_from_cif_ccp4 ( int & type, PCMMCIFLoop loop,
-                                    cpstr Tag, int row, int & rc )  {
-pstr p;
-   p = loop->GetString ( Tag,row,rc );
-   if (!p)                         type = CCP4SRSBond::noOrder;
-   else if (!strcmp(p,"single"))   type = CCP4SRSBond::Single;
-   else if (!strcmp(p,"aromatic")) type = CCP4SRSBond::Aromatic;
-   else if (!strcmp(p,"aromat"))   type = CCP4SRSBond::Aromatic;
-   else if (!strcmp(p,"double"))   type = CCP4SRSBond::Double;
-   else if (!strcmp(p,"triple"))   type = CCP4SRSBond::Triple;
-   else if (!strcmp(p,"deloc"))    type = CCP4SRSBond::Deloc;
-   else if (!strcmp(p,"coval"))    type = CCP4SRSBond::Covalent;
-   else if (!strcmp(p,"metal"))    type = CCP4SRSBond::Metal;
-   else  {
-     type = CCP4SRSBond::noOrder;
-     rc   = CCP4SRS_WrongBondType;
-   }
-}
-
-void  get_bond_type_from_cif_rcsb ( int & type, PCMMCIFLoop loop,
-                                    cpstr Tag, int row, int & rc )  {
-pstr p;
-   p = loop->GetString ( Tag,row,rc );
-   if (!p)                         type = CCP4SRSBond::noOrder;
-   else if (!strcmp(p,"SING"))   type = CCP4SRSBond::Single;
-   else if (!strcmp(p,"AROM"))   type = CCP4SRSBond::Aromatic;
-   else if (!strcmp(p,"DOUB"))   type = CCP4SRSBond::Double;
-   else if (!strcmp(p,"TRIP"))   type = CCP4SRSBond::Triple;
-   else  {
-     type = CCP4SRSBond::noOrder;
-     rc   = CCP4SRS_WrongBondType;
-   }
-}
-
-void  get_bond_type_from_cif ( int & type, PCMMCIFStruct mmCIFStruct,
-                               cpstr Tag, int & rc )  {
-pstr p;
-   p = mmCIFStruct->GetString ( Tag,rc );
-   if (!p)                       type = CCP4SRSBond::noOrder;
-   else if (!strcmp(p,"SING"))   type = CCP4SRSBond::Single;
-   else if (!strcmp(p,"AROM"))   type = CCP4SRSBond::Aromatic;
-   else if (!strcmp(p,"DOUB"))   type = CCP4SRSBond::Double;
-   else if (!strcmp(p,"TRIP"))   type = CCP4SRSBond::Triple;
-   else  {
-     type = CCP4SRSBond::noOrder;
-     rc   = CCP4SRS_WrongBondType;
-   }
-}
-
-void add_bond_type_to_cif ( PCMMCIFLoop loop, int type )  {
-  switch (type)  {
-    default:
-    case CCP4SRSBond::noOrder:  loop->AddNoData ( CIF_NODATA_DOT   );
-                              break;
-    case CCP4SRSBond::Single:   loop->AddString ( "single"  ,False );
-                              break;
-    case CCP4SRSBond::Aromatic: loop->AddString ( "aromatic",False );
-                              break;
-    case CCP4SRSBond::Double:   loop->AddString ( "double"  ,False );
-                              break;
-    case CCP4SRSBond::Triple:   loop->AddString ( "triple"  ,False );
-                              break;
-    case CCP4SRSBond::Deloc:    loop->AddString ( "deloc"   ,False );
-  }
-}
-
-
-int CCP4SRSBond::readFromCIF_ccp4 ( PCMMCIFLoop mmCIFLoop, int bondNo,
-                             CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-int rc;
-
-  rc = 0;
-
-  get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
-                      bondNo,atoms,rc );
-  get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
-                      bondNo,atoms,rc );
-  get_bond_type_from_cif_ccp4 ( bond_order,mmCIFLoop,MMCIF_TAG_TYPE,
-                      bondNo,rc );
-
-  if (mmCIFLoop->GetTagNo(MMCIF_TAG_VALUE_DIST)>=0)  {
-    mmCIFLoop->CopyReal ( bond_length    ,MMCIF_TAG_VALUE_DIST    ,
-                          bondNo,rc );
-    mmCIFLoop->CopyReal ( bond_length_esd,MMCIF_TAG_VALUE_DIST_ESD,
-                          bondNo,rc );
-  } else  {
+namespace ccp4srs  {
+
+  Bond::Bond()  {
+    atom_1          = -1;
+    atom_2          = -1;
+    bond_order      = Bond::noOrder;
+  //  bond_type       = Bond::noType;
     bond_length     = 0.0;
     bond_length_esd = 0.0;
   }
 
-  return rc;
+  Bond::~Bond()  {
+  }
 
-}
 
+  void  get_bond_type_from_cif_ccp4 ( int & type, mmdb::mmcif::PLoop loop,
+                                      mmdb::cpstr Tag, int row, int & rc )  {
+  mmdb::pstr p;
+     p = loop->GetString ( Tag,row,rc );
+     if (!p)                         type = Bond::noOrder;
+     else if (!strcmp(p,"single"))   type = Bond::Single;
+     else if (!strcmp(p,"aromatic")) type = Bond::Aromatic;
+     else if (!strcmp(p,"aromat"))   type = Bond::Aromatic;
+     else if (!strcmp(p,"double"))   type = Bond::Double;
+     else if (!strcmp(p,"triple"))   type = Bond::Triple;
+     else if (!strcmp(p,"deloc"))    type = Bond::Deloc;
+     else if (!strcmp(p,"coval"))    type = Bond::Covalent;
+     else if (!strcmp(p,"metal"))    type = Bond::Metal;
+     else  {
+       type = Bond::noOrder;
+       rc   = CCP4SRS_WrongBondType;
+     }
+  }
 
-int CCP4SRSBond::readFromCIF_rcsb ( PCMMCIFLoop mmCIFLoop, int bondNo,
-                             CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-pstr p;
-int  rc;
-
-  rc = 0;
-
-  get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
-                      bondNo,atoms,rc );
-  get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
-                      bondNo,atoms,rc );
-  get_bond_type_from_cif_rcsb ( bond_order,mmCIFLoop,
-                      MMCIF_TAG_VALUE_ORDER,bondNo,rc );
-
-  if ((bond_order==CCP4SRSBond::Single) ||
-      (bond_order==CCP4SRSBond::Double))  {
-    p = mmCIFLoop->GetString ( MMCIF_TAG_PDBX_AROMATIC_FLAG,bondNo,rc );
-    if (p)  {
-      if (p[0]=='Y')
-        bond_order = CCP4SRSBond::Aromatic;
-    }
+  void  get_bond_type_from_cif_rcsb ( int & type,
+                                      mmdb::mmcif::PLoop loop,
+                                      mmdb::cpstr Tag,
+                                      int row, int & rc )  {
+  mmdb::pstr p;
+     p = loop->GetString ( Tag,row,rc );
+     if (!p)                       type = Bond::noOrder;
+     else if (!strcmp(p,"SING"))   type = Bond::Single;
+     else if (!strcmp(p,"AROM"))   type = Bond::Aromatic;
+     else if (!strcmp(p,"DOUB"))   type = Bond::Double;
+     else if (!strcmp(p,"TRIP"))   type = Bond::Triple;
+     else  {
+       type = Bond::noOrder;
+       rc   = CCP4SRS_WrongBondType;
+     }
   }
 
-  bond_length     = 0.0;
-  bond_length_esd = 0.0;
+  void  get_bond_type_from_cif ( int & type,
+                                 mmdb::mmcif::PStruct mmCIFStruct,
+                                 mmdb::cpstr Tag, int & rc )  {
+  mmdb::pstr p;
+     p = mmCIFStruct->GetString ( Tag,rc );
+     if (!p)                       type = Bond::noOrder;
+     else if (!strcmp(p,"SING"))   type = Bond::Single;
+     else if (!strcmp(p,"AROM"))   type = Bond::Aromatic;
+     else if (!strcmp(p,"DOUB"))   type = Bond::Double;
+     else if (!strcmp(p,"TRIP"))   type = Bond::Triple;
+     else  {
+       type = Bond::noOrder;
+       rc   = CCP4SRS_WrongBondType;
+     }
+  }
 
-  return rc;
+  void add_bond_type_to_cif ( mmdb::mmcif::PLoop loop, int type )  {
+    switch (type)  {
+      default:
+      case Bond::noOrder:  loop->AddNoData ( mmdb::mmcif::CIF_NODATA_DOT );
+                                break;
+      case Bond::Single:   loop->AddString ( "single"  ,false );
+                                break;
+      case Bond::Aromatic: loop->AddString ( "aromatic",false );
+                                break;
+      case Bond::Double:   loop->AddString ( "double"  ,false );
+                                break;
+      case Bond::Triple:   loop->AddString ( "triple"  ,false );
+                                break;
+      case Bond::Deloc:    loop->AddString ( "deloc"   ,false );
+    }
+  }
 
-}
 
-int CCP4SRSBond::readFromCIF ( PCMMCIFStruct mmCIFStruct,
-                               CCP4SRSContainer<CCP4SRSAtom> & atoms ) {
-pstr p;
-int  rc;
-
-  rc = 0;
-
-  get_atom_from_cif ( atom_1,mmCIFStruct,MMCIF_TAG_ATOM_ID_1,
-                      atoms,rc );
-  get_atom_from_cif ( atom_2,mmCIFStruct,MMCIF_TAG_ATOM_ID_2,
-                      atoms,rc );
-  get_bond_type_from_cif ( bond_order,mmCIFStruct,
-                      MMCIF_TAG_VALUE_ORDER,rc );
-
-  if ((bond_order==CCP4SRSBond::Single) ||
-      (bond_order==CCP4SRSBond::Double))  {
-    p = mmCIFStruct->GetString ( MMCIF_TAG_PDBX_AROMATIC_FLAG,rc );
-    if (p)  {
-      if (p[0]=='Y')
-        bond_order = CCP4SRSBond::Aromatic;
+  int Bond::readFromCIF_ccp4 ( mmdb::mmcif::PLoop mmCIFLoop,
+                               int bondNo,
+                               Container<Atom> & atoms )  {
+  int rc;
+
+    rc = 0;
+
+    get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
+                        bondNo,atoms,rc );
+    get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
+                        bondNo,atoms,rc );
+    get_bond_type_from_cif_ccp4 ( bond_order,mmCIFLoop,MMCIF_TAG_TYPE,
+                        bondNo,rc );
+
+    if (mmCIFLoop->GetTagNo(MMCIF_TAG_VALUE_DIST)>=0)  {
+      mmCIFLoop->CopyReal ( bond_length    ,MMCIF_TAG_VALUE_DIST    ,
+                            bondNo,rc );
+      mmCIFLoop->CopyReal ( bond_length_esd,MMCIF_TAG_VALUE_DIST_ESD,
+                            bondNo,rc );
+    } else  {
+      bond_length     = 0.0;
+      bond_length_esd = 0.0;
     }
+
+    return rc;
+
   }
 
-  bond_length     = 0.0;
-  bond_length_esd = 0.0;
 
-  return rc;
+  int Bond::readFromCIF_rcsb ( mmdb::mmcif::PLoop mmCIFLoop,
+                               int bondNo,
+                               Container<Atom> & atoms )  {
+  mmdb::pstr p;
+  int        rc;
+
+    rc = 0;
+
+    get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
+                        bondNo,atoms,rc );
+    get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
+                        bondNo,atoms,rc );
+    get_bond_type_from_cif_rcsb ( bond_order,mmCIFLoop,
+                        MMCIF_TAG_VALUE_ORDER,bondNo,rc );
+
+    if ((bond_order==Bond::Single) ||
+        (bond_order==Bond::Double))  {
+      p = mmCIFLoop->GetString ( MMCIF_TAG_PDBX_AROMATIC_FLAG,bondNo,rc );
+      if (p)  {
+        if (p[0]=='Y')
+          bond_order = Bond::Aromatic;
+      }
+    }
 
-}
+    bond_length     = 0.0;
+    bond_length_esd = 0.0;
 
-/*
-loop_
-_chem_comp_bond.comp_id
-_chem_comp_bond.atom_id_1
-_chem_comp_bond.atom_id_2
-_chem_comp_bond.type
-_chem_comp_bond.value_dist
-_chem_comp_bond.value_dist_esd
- ATP      O1G    PG        deloc       1.510    0.020
-*/
+    return rc;
 
+  }
 
-Boolean CCP4SRSBond::compare ( CCP4SRSContainer<CCP4SRSAtom> & atoms,
-                       PCCP4SRSBond bond,
-                       CCP4SRSContainer<CCP4SRSAtom> & bond_atoms )  {
-AtomName a11,a12, a21,a22;
+  int Bond::readFromCIF ( mmdb::mmcif::PStruct mmCIFStruct,
+                                 Container<Atom> & atoms ) {
+  mmdb::pstr p;
+  int        rc;
+
+    rc = 0;
+
+    get_atom_from_cif ( atom_1,mmCIFStruct,MMCIF_TAG_ATOM_ID_1,
+                        atoms,rc );
+    get_atom_from_cif ( atom_2,mmCIFStruct,MMCIF_TAG_ATOM_ID_2,
+                        atoms,rc );
+    get_bond_type_from_cif ( bond_order,mmCIFStruct,
+                        MMCIF_TAG_VALUE_ORDER,rc );
+
+    if ((bond_order==Bond::Single) ||
+        (bond_order==Bond::Double))  {
+      p = mmCIFStruct->GetString ( MMCIF_TAG_PDBX_AROMATIC_FLAG,rc );
+      if (p)  {
+        if (p[0]=='Y')
+          bond_order = Bond::Aromatic;
+      }
+    }
 
-  strcpy ( a11,atoms.at(atom_1)->id() );
-  strcpy ( a12,atoms.at(atom_2)->id() );
+    bond_length     = 0.0;
+    bond_length_esd = 0.0;
 
-  strcpy ( a21,bond_atoms.at(bond->atom1())->id() );
-  strcpy ( a22,bond_atoms.at(bond->atom2())->id() );
+    return rc;
 
-  if (!strcmp(a11,a21))
-    return (strcmp(a12,a22)==0);
-  else if (!strcmp(a11,a22))
-    return (strcmp(a12,a21)==0);
+  }
 
-  return False;
+  /*
+  loop_
+  _chem_comp_bond.comp_id
+  _chem_comp_bond.atom_id_1
+  _chem_comp_bond.atom_id_2
+  _chem_comp_bond.type
+  _chem_comp_bond.value_dist
+  _chem_comp_bond.value_dist_esd
+   ATP      O1G    PG        deloc       1.510    0.020
+  */
+
+
+  bool Bond::compare ( Container<Atom> & atoms, PBond bond,
+                       Container<Atom> & bond_atoms )  {
+  mmdb::AtomName a11,a12, a21,a22;
+
+    strcpy ( a11,atoms.at(atom_1)->id() );
+    strcpy ( a12,atoms.at(atom_2)->id() );
+
+    strcpy ( a21,bond_atoms.at(bond->atom1())->id() );
+    strcpy ( a22,bond_atoms.at(bond->atom2())->id() );
+
+    if (!strcmp(a11,a21))
+      return (strcmp(a12,a22)==0);
+    else if (!strcmp(a11,a22))
+      return (strcmp(a12,a21)==0);
 
-}
+    return false;
 
-Boolean CCP4SRSBond::copy ( CCP4SRSContainer<CCP4SRSAtom> & atoms,
-                       PCCP4SRSBond bond,
-                       CCP4SRSContainer<CCP4SRSAtom> & bond_atoms )  {
-AtomName a1,a2;
-int      i;
+  }
 
-  strcpy ( a1,bond_atoms.at(bond->atom1())->id() );
-  strcpy ( a2,bond_atoms.at(bond->atom2())->id() );
+  bool Bond::copy ( Container<Atom> & atoms,
+                         PBond bond,
+                         Container<Atom> & bond_atoms )  {
+  mmdb::AtomName a1,a2;
+  int      i;
+
+    strcpy ( a1,bond_atoms.at(bond->atom1())->id() );
+    strcpy ( a2,bond_atoms.at(bond->atom2())->id() );
+
+    atom_1 = -1;
+    atom_2 = -1;
+
+    for (i=0;(i<atoms.numberOf());i++)  {
+      if (!strcmp(atoms.at(i)->id(),a1))  atom_1 = i;
+      if (!strcmp(atoms.at(i)->id(),a2))  atom_2 = i;
+    }
 
-  atom_1 = -1;
-  atom_2 = -1;
+    if ((atom_1>=0) && (atom_2>=0))  {
+      bond_order      = bond->order ();
+      bond_length     = bond->length();
+      bond_length_esd = bond->length_esd();
+      return true;
+    }
+
+    return false;
 
-  for (i=0;(i<atoms.numberOf());i++)  {
-    if (!strcmp(atoms.at(i)->id(),a1))  atom_1 = i;
-    if (!strcmp(atoms.at(i)->id(),a2))  atom_2 = i;
   }
 
-  if ((atom_1>=0) && (atom_2>=0))  {
-    bond_order      = bond->order ();
-    bond_length     = bond->length();
+  void Bond::copy ( PBond bond, mmdb::ivector anmatch )  {
+    if (anmatch)  {
+      atom_1 = anmatch[bond->atom1()];
+      atom_2 = anmatch[bond->atom2()];
+    } else  {
+      atom_1 = bond->atom1();
+      atom_2 = bond->atom2();
+    }
+    bond_order      = bond->order     ();
+    bond_length     = bond->length    ();
     bond_length_esd = bond->length_esd();
-    return True;
   }
 
-  return False;
 
-}
+  void Bond::makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop )  {
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID        );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_1      );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_2      );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_TYPE           );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_DIST     );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_DIST_ESD );
+  }
+
+  void Bond::writeToCIF ( mmdb::mmcif::PLoop mmCIFLoop,
+                              mmdb::cpstr monID,
+                              Container<Atom> & atoms )  {
+    mmCIFLoop->AddString ( monID,false              );
+    add_atom_to_cif      ( mmCIFLoop,atom_1,atoms   );
+    add_atom_to_cif      ( mmCIFLoop,atom_2,atoms   );
+    add_bond_type_to_cif ( mmCIFLoop,bond_order     );
+    mmCIFLoop->AddReal   ( bond_length    ,"%10.3f" );
+    mmCIFLoop->AddReal   ( bond_length_esd,"%10.3f" );
+  }
+
+  void Bond::write_mem ( PMemIO memIO, int version )  {
+  UNUSED_ARGUMENT(version);
+    memIO->put_integer ( atom_1          );
+    memIO->put_integer ( atom_2          );
+    memIO->put_ibyte   ( bond_order      );
+  //  memIO->put_ibyte   ( bond_type       );
+    memIO->put_float   ( bond_length     );
+    memIO->put_float   ( bond_length_esd );
+  }
+
+  bool Bond::read_mem ( PMemIO memIO, int version, bool * Ok )  {
+  UNUSED_ARGUMENT(version);
+  bool success;
+    if (Ok)  success = *Ok;
+       else  success = true;
+    memIO->get_integer ( atom_1         ,&success );
+    memIO->get_integer ( atom_2         ,&success );
+    memIO->get_ibyte   ( bond_order     ,&success );
+  //  memIO->get_ibyte   ( bond_type      ,&success );
+    memIO->get_float   ( bond_length    ,&success );
+    memIO->get_float   ( bond_length_esd,&success );
+    if (Ok)  *Ok = success;
+    return success;
+  }
 
-void CCP4SRSBond::copy ( PCCP4SRSBond bond, ivector anmatch )  {
-  if (anmatch)  {
-    atom_1 = anmatch[bond->atom1()];
-    atom_2 = anmatch[bond->atom2()];
-  } else  {
-    atom_1 = bond->atom1();
-    atom_2 = bond->atom2();
-  }
-  bond_order      = bond->order     ();
-  bond_length     = bond->length    ();
-  bond_length_esd = bond->length_esd();
-}
-
-
-void CCP4SRSBond::makeCIFTags ( PCMMCIFLoop mmCIFLoop )  {
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID        );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_1      );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_2      );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_TYPE           );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_DIST     );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_DIST_ESD );
-}
-
-void CCP4SRSBond::writeToCIF ( PCMMCIFLoop mmCIFLoop, cpstr monID,
-                            CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-  mmCIFLoop->AddString ( monID,False              );
-  add_atom_to_cif      ( mmCIFLoop,atom_1,atoms   );
-  add_atom_to_cif      ( mmCIFLoop,atom_2,atoms   );
-  add_bond_type_to_cif ( mmCIFLoop,bond_order     );
-  mmCIFLoop->AddReal   ( bond_length    ,"%10.3f" );
-  mmCIFLoop->AddReal   ( bond_length_esd,"%10.3f" );
-}
-
-void CCP4SRSBond::write_mem ( PCMemIO memIO, int version )  {
-UNUSED_ARGUMENT(version);
-  memIO->put_integer ( atom_1          );
-  memIO->put_integer ( atom_2          );
-  memIO->put_ibyte   ( bond_order      );
-//  memIO->put_ibyte   ( bond_type       );
-  memIO->put_float   ( bond_length     );
-  memIO->put_float   ( bond_length_esd );
-}
-
-Boolean CCP4SRSBond::read_mem ( PCMemIO memIO, int version,
-                                Boolean * Ok )  {
-UNUSED_ARGUMENT(version);
-Boolean success;
-  if (Ok)  success = *Ok;
-     else  success = True;
-  memIO->get_integer ( atom_1         ,&success );
-  memIO->get_integer ( atom_2         ,&success );
-  memIO->get_ibyte   ( bond_order     ,&success );
-//  memIO->get_ibyte   ( bond_type      ,&success );
-  memIO->get_float   ( bond_length    ,&success );
-  memIO->get_float   ( bond_length_esd,&success );
-  if (Ok)  *Ok = success;
-  return success;
-}
+}  // namespace ccp4srs
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_bond.h ccp4srs/ccp4srs/ccp4srs_bond.h
--- ccp4srs-old/ccp4srs/ccp4srs_bond.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_bond.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_bond.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_bond.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    18.10.11   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_bond  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSBond  - atom description class
+//  **** Classes :  ccp4srs::Bond  - atom description class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010-2011
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
@@ -41,56 +41,58 @@
 
 #include "ccp4srs_atom.h"
 
-DefineClass(CCP4SRSBond);
+namespace ccp4srs  {
 
-class CCP4SRSBond  {
+  DefineClass(Bond);
 
-  public:
+  class Bond  {
 
-    //  bond orders
-    enum {noOrder,Single,Aromatic,Double,Triple,Deloc,Covalent,Metal};
+    public:
 
-    CCP4SRSBond();
-    virtual ~CCP4SRSBond();
-
-    inline int      atom1     () { return atom_1;          }
-    inline int      atom2     () { return atom_2;          }
-    inline int      order     () { return bond_order;      }
-    inline realtype length    () { return bond_length;     }
-    inline realtype length_esd() { return bond_length_esd; }
-
-    static void makeCIFTags ( PCMMCIFLoop mmCIFLoop );
-    int  readFromCIF_ccp4 ( PCMMCIFLoop mmCIFLoop, int bondNo,
-                            CCP4SRSContainer<CCP4SRSAtom> & atoms );
-    int  readFromCIF_rcsb ( PCMMCIFLoop mmCIFLoop, int bondNo,
-                            CCP4SRSContainer<CCP4SRSAtom> & atoms );
-    int  readFromCIF ( PCMMCIFStruct mmCIFStruct,
-                       CCP4SRSContainer<CCP4SRSAtom> & atoms );
-    void writeToCIF  ( PCMMCIFLoop mmCIFLoop, cpstr monID,
-                       CCP4SRSContainer<CCP4SRSAtom> & atoms );
-
-    Boolean compare ( CCP4SRSContainer<CCP4SRSAtom> & atoms,
-                      PCCP4SRSBond bond,
-                      CCP4SRSContainer<CCP4SRSAtom> & bond_atoms );
-
-    Boolean copy    ( CCP4SRSContainer<CCP4SRSAtom> & atoms,
-                      PCCP4SRSBond bond,
-                      CCP4SRSContainer<CCP4SRSAtom> & bond_atoms );
-
-    void    write_mem ( PCMemIO memIO, int version );
-    Boolean read_mem  ( PCMemIO memIO, int version,
-                        Boolean * Ok = NULL );
-
-    void copy  ( PCCP4SRSBond bond, ivector anmatch=NULL );
-
-  protected:
-    int      atom_1,atom_2;   //!< ordinal numbers of bonded atoms [0,1,.]
-    int      bond_order;      //!< bond order
-    realtype bond_length;     //!< bond length in A; set to 0.0 if
-                              ///< not provided
-    realtype bond_length_esd; //!< bond length esd in A; set to 0.0 if
-                              /// not provided
+      //  bond orders
+      enum {noOrder,Single,Aromatic,Double,Triple,Deloc,Covalent,Metal};
 
-};
+      Bond();
+      virtual ~Bond();
+
+      inline int      atom1     () { return atom_1;          }
+      inline int      atom2     () { return atom_2;          }
+      inline int      order     () { return bond_order;      }
+      inline mmdb::realtype length    () { return bond_length;     }
+      inline mmdb::realtype length_esd() { return bond_length_esd; }
+
+      static void makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop );
+      int  readFromCIF_ccp4 ( mmdb::mmcif::PLoop mmCIFLoop, int bondNo,
+                              Container<Atom> & atoms );
+      int  readFromCIF_rcsb ( mmdb::mmcif::PLoop mmCIFLoop, int bondNo,
+                              Container<Atom> & atoms );
+      int  readFromCIF ( mmdb::mmcif::PStruct mmCIFStruct,
+                         Container<Atom> & atoms );
+      void writeToCIF  ( mmdb::mmcif::PLoop mmCIFLoop, mmdb::cpstr monID,
+                         Container<Atom> & atoms );
+
+      bool compare ( Container<Atom> & atoms, PBond bond,
+                     Container<Atom> & bond_atoms );
+
+      bool copy    ( Container<Atom> & atoms, PBond bond,
+                     Container<Atom> & bond_atoms );
+
+      void write_mem ( PMemIO memIO, int version );
+      bool read_mem  ( PMemIO memIO, int version,
+                          bool * Ok = NULL );
+
+      void copy  ( PBond bond, mmdb::ivector anmatch=NULL );
+
+    protected:
+      int            atom_1,atom_2;   //!< ordinal numbers of bonded atoms [0,1,.]
+      int            bond_order;      //!< bond order
+      mmdb::realtype bond_length;     //!< bond length in A; set to 0.0 if
+                                      ///< not provided
+      mmdb::realtype bond_length_esd; //!< bond length esd in A; set to 0.0 if
+                                      /// not provided
+
+  };
+
+}  // namespace ccp4srs
 
 #endif // CCP4SRS_BOND_H
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_chem.cpp ccp4srs/ccp4srs/ccp4srs_chem.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_chem.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_chem.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_chem.cpp, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_chem.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,13 +22,13 @@
 //
 //  =================================================================
 //
-//    26.02.13   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_chem  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSChem - SRS chemistry manager class
+//  **** Classes :  ccp4srs::Chem - SRS chemistry manager class
 //       ~~~~~~~~~
 //
 //  (C) E. Krissinel 2010-2013
